# BSD 3-Clause "New" or "Revised" License (BSD-3-Clause) 
# Copyright (c) 2020 Stephen McCalman. All rights reserved.

# flake8: noqa

"""
A Python client package for accessing data from an API that follows the Consumer Data Standards (CDS).
CDS repo: https://consumerdatastandardsaustralia.github.io/standards

Generated with the Swagger-Codegen CLI from a Swagger specification file of the Consumer Data Standards.
Do not edit this file manually. CLI repo: https://github.com/swagger-api/swagger-codegen
    
The package is NOT part of the official Consumer Data Standards' project nor any API implementation of the Standards.
Package repo: https://github.com/stephenmccalman/cds-python-api-client
"""


__version__ = "0.0.2"
__author__ = "Stephen McCalman"
__email__ = "cds-api-client@googlegroups.com"
__license__ =  'BSD 3-Clause "New" or "Revised" License (BSD-3-Clause)'
__copyright__ = "Copyright (c) 2020 Stephen McCalman. All rights reserved."

# import apis into sdk package
from cds.api.accounts_api import AccountsApi
from cds.api.banking_api import BankingApi
from cds.api.common_api import CommonApi
from cds.api.customer_api import CustomerApi
from cds.api.direct_debits_api import DirectDebitsApi
from cds.api.discovery_api import DiscoveryApi
from cds.api.payees_api import PayeesApi
from cds.api.products_api import ProductsApi
from cds.api.scheduled_payments_api import ScheduledPaymentsApi

# import ApiClient
from cds.api_client import ApiClient
from cds.configuration import Configuration
# import models into sdk package
from cds.models.banking_account import BankingAccount
from cds.models.banking_authorised_entity import BankingAuthorisedEntity
from cds.models.banking_balance import BankingBalance
from cds.models.banking_balance_purse import BankingBalancePurse
from cds.models.banking_biller_payee import BankingBillerPayee
from cds.models.banking_credit_card_account import BankingCreditCardAccount
from cds.models.banking_direct_debit import BankingDirectDebit
from cds.models.banking_domestic_payee import BankingDomesticPayee
from cds.models.banking_domestic_payee_account import BankingDomesticPayeeAccount
from cds.models.banking_domestic_payee_card import BankingDomesticPayeeCard
from cds.models.banking_domestic_payee_pay_id import BankingDomesticPayeePayId
from cds.models.banking_international_payee import BankingInternationalPayee
from cds.models.banking_international_payee_bank_details import BankingInternationalPayeeBankDetails
from cds.models.banking_international_payee_bank_details_bank_address import BankingInternationalPayeeBankDetailsBankAddress
from cds.models.banking_international_payee_beneficiary_details import BankingInternationalPayeeBeneficiaryDetails
from cds.models.banking_loan_account import BankingLoanAccount
from cds.models.banking_payee import BankingPayee
from cds.models.banking_product_bundle import BankingProductBundle
from cds.models.banking_product_category import BankingProductCategory
from cds.models.banking_product_constraint import BankingProductConstraint
from cds.models.banking_product_deposit_rate import BankingProductDepositRate
from cds.models.banking_product_discount import BankingProductDiscount
from cds.models.banking_product_discount_eligibility import BankingProductDiscountEligibility
from cds.models.banking_product_eligibility import BankingProductEligibility
from cds.models.banking_product_feature import BankingProductFeature
from cds.models.banking_product_fee import BankingProductFee
from cds.models.banking_product_lending_rate import BankingProductLendingRate
from cds.models.banking_product_rate_condition import BankingProductRateCondition
from cds.models.banking_product_rate_tier import BankingProductRateTier
from cds.models.banking_product_rate_tier_sub_tier import BankingProductRateTierSubTier
from cds.models.banking_product_v2 import BankingProductV2
from cds.models.banking_product_v2_additional_information import BankingProductV2AdditionalInformation
from cds.models.banking_product_v2_card_art import BankingProductV2CardArt
from cds.models.banking_scheduled_payment import BankingScheduledPayment
from cds.models.banking_scheduled_payment_from import BankingScheduledPaymentFrom
from cds.models.banking_scheduled_payment_interval import BankingScheduledPaymentInterval
from cds.models.banking_scheduled_payment_recurrence import BankingScheduledPaymentRecurrence
from cds.models.banking_scheduled_payment_recurrence_event_based import BankingScheduledPaymentRecurrenceEventBased
from cds.models.banking_scheduled_payment_recurrence_interval_schedule import BankingScheduledPaymentRecurrenceIntervalSchedule
from cds.models.banking_scheduled_payment_recurrence_last_weekday import BankingScheduledPaymentRecurrenceLastWeekday
from cds.models.banking_scheduled_payment_recurrence_once_off import BankingScheduledPaymentRecurrenceOnceOff
from cds.models.banking_scheduled_payment_set import BankingScheduledPaymentSet
from cds.models.banking_scheduled_payment_to import BankingScheduledPaymentTo
from cds.models.banking_term_deposit_account import BankingTermDepositAccount
from cds.models.banking_transaction import BankingTransaction
from cds.models.banking_transaction_detail_extended_data import BankingTransactionDetailExtendedData
from cds.models.banking_transaction_detail_extended_data_x2p101_payload import BankingTransactionDetailExtendedDataX2p101Payload
from cds.models.common_email_address import CommonEmailAddress
from cds.models.common_organisation import CommonOrganisation
from cds.models.common_paf_address import CommonPAFAddress
from cds.models.common_person import CommonPerson
from cds.models.common_phone_number import CommonPhoneNumber
from cds.models.common_physical_address import CommonPhysicalAddress
from cds.models.common_simple_address import CommonSimpleAddress
from cds.models.discovery_outage import DiscoveryOutage
from cds.models.links import Links
from cds.models.links_paginated import LinksPaginated
from cds.models.meta import Meta
from cds.models.meta_paginated import MetaPaginated
from cds.models.request_account_ids import RequestAccountIds
from cds.models.request_account_ids_data import RequestAccountIdsData
from cds.models.response_banking_account_by_id import ResponseBankingAccountById
from cds.models.response_banking_account_list import ResponseBankingAccountList
from cds.models.response_banking_account_list_data import ResponseBankingAccountListData
from cds.models.response_banking_accounts_balance_by_id import ResponseBankingAccountsBalanceById
from cds.models.response_banking_accounts_balance_list import ResponseBankingAccountsBalanceList
from cds.models.response_banking_accounts_balance_list_data import ResponseBankingAccountsBalanceListData
from cds.models.response_banking_direct_debit_authorisation_list import ResponseBankingDirectDebitAuthorisationList
from cds.models.response_banking_direct_debit_authorisation_list_data import ResponseBankingDirectDebitAuthorisationListData
from cds.models.response_banking_payee_by_id import ResponseBankingPayeeById
from cds.models.response_banking_payee_list import ResponseBankingPayeeList
from cds.models.response_banking_payee_list_data import ResponseBankingPayeeListData
from cds.models.response_banking_product_by_id import ResponseBankingProductById
from cds.models.response_banking_product_list import ResponseBankingProductList
from cds.models.response_banking_product_list_data import ResponseBankingProductListData
from cds.models.response_banking_scheduled_payments_list import ResponseBankingScheduledPaymentsList
from cds.models.response_banking_scheduled_payments_list_data import ResponseBankingScheduledPaymentsListData
from cds.models.response_banking_transaction_by_id import ResponseBankingTransactionById
from cds.models.response_banking_transaction_list import ResponseBankingTransactionList
from cds.models.response_banking_transaction_list_data import ResponseBankingTransactionListData
from cds.models.response_common_customer import ResponseCommonCustomer
from cds.models.response_common_customer_data import ResponseCommonCustomerData
from cds.models.response_common_customer_detail import ResponseCommonCustomerDetail
from cds.models.response_common_customer_detail_data import ResponseCommonCustomerDetailData
from cds.models.response_common_discovery_status import ResponseCommonDiscoveryStatus
from cds.models.response_common_discovery_status_data import ResponseCommonDiscoveryStatusData
from cds.models.response_discovery_outages_list import ResponseDiscoveryOutagesList
from cds.models.response_discovery_outages_list_data import ResponseDiscoveryOutagesListData
from cds.models.response_error_list import ResponseErrorList
from cds.models.response_error_list_errors import ResponseErrorListErrors
from cds.models.banking_account_detail import BankingAccountDetail
from cds.models.banking_payee_detail import BankingPayeeDetail
from cds.models.banking_product_detail import BankingProductDetail
from cds.models.banking_transaction_detail import BankingTransactionDetail
from cds.models.common_organisation_detail import CommonOrganisationDetail
from cds.models.common_person_detail import CommonPersonDetail
from cds.models.common_physical_address_with_purpose import CommonPhysicalAddressWithPurpose

