# BSD 3-Clause "New" or "Revised" License (BSD-3-Clause) 
# Copyright (c) 2020 Stephen McCalman. All rights reserved.

"""
A Python client package for accessing data from an API that follows the Consumer Data Standards (CDS).
CDS repo: https://consumerdatastandardsaustralia.github.io/standards

Generated with the Swagger-Codegen CLI from a Swagger specification file of the Consumer Data Standards.
Do not edit this file manually. CLI repo: https://github.com/swagger-api/swagger-codegen
    
The package is NOT part of the official Consumer Data Standards' project nor any API implementation of the Standards.
Package repo: https://github.com/stephenmccalman/cds-python-api-client
"""


import pprint
import re  # noqa: F401

class BankingInternationalPayeeBeneficiaryDetails(object):
    """BankingInternationalPayeeBeneficiaryDetails class."""
    


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'country': 'str',
        'message': 'str'
    }

    attribute_map = {
        'name': 'name',
        'country': 'country',
        'message': 'message'
    }

    def __init__(self, name=None, country=None, message=None):  # noqa: E501
        """BankingInternationalPayeeBeneficiaryDetails"""  # noqa: E501

        self._name = None
        self._country = None
        self._message = None
        self.discriminator = None

        if name is not None:
            self.name = name
        self.country = country
        if message is not None:
            self.message = message

    @property
    def name(self):
        """Gets the name of this BankingInternationalPayeeBeneficiaryDetails.  # noqa: E501

        Name of the beneficiary  # noqa: E501

        :return: The name of this BankingInternationalPayeeBeneficiaryDetails.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this BankingInternationalPayeeBeneficiaryDetails.

        Name of the beneficiary  # noqa: E501

        :param name: The name of this BankingInternationalPayeeBeneficiaryDetails.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def country(self):
        """Gets the country of this BankingInternationalPayeeBeneficiaryDetails.  # noqa: E501

        Country where the beneficiary resides. A valid [ISO 3166 Alpha-3](https://www.iso.org/iso-3166-country-codes.html) country code  # noqa: E501

        :return: The country of this BankingInternationalPayeeBeneficiaryDetails.  # noqa: E501
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country):
        """Sets the country of this BankingInternationalPayeeBeneficiaryDetails.

        Country where the beneficiary resides. A valid [ISO 3166 Alpha-3](https://www.iso.org/iso-3166-country-codes.html) country code  # noqa: E501

        :param country: The country of this BankingInternationalPayeeBeneficiaryDetails.  # noqa: E501
        :type: str
        """
        if country is None:
            raise ValueError("Invalid value for `country`, must not be `None`")  # noqa: E501

        self._country = country

    @property
    def message(self):
        """Gets the message of this BankingInternationalPayeeBeneficiaryDetails.  # noqa: E501

        Response message for the payment  # noqa: E501

        :return: The message of this BankingInternationalPayeeBeneficiaryDetails.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this BankingInternationalPayeeBeneficiaryDetails.

        Response message for the payment  # noqa: E501

        :param message: The message of this BankingInternationalPayeeBeneficiaryDetails.  # noqa: E501
        :type: str
        """

        self._message = message

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BankingInternationalPayeeBeneficiaryDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BankingInternationalPayeeBeneficiaryDetails):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
