# BSD 3-Clause "New" or "Revised" License (BSD-3-Clause) 
# Copyright (c) 2020 Stephen McCalman. All rights reserved.

"""
A Python client package for accessing data from an API that follows the Consumer Data Standards (CDS).
CDS repo: https://consumerdatastandardsaustralia.github.io/standards

Generated with the Swagger-Codegen CLI from a Swagger specification file of the Consumer Data Standards.
Do not edit this file manually. CLI repo: https://github.com/swagger-api/swagger-codegen
    
The package is NOT part of the official Consumer Data Standards' project nor any API implementation of the Standards.
Package repo: https://github.com/stephenmccalman/cds-python-api-client
"""


import pprint
import re  # noqa: F401

class ResponseBankingPayeeListData(object):
    """ResponseBankingPayeeListData class."""
    


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'payees': 'list[BankingPayee]'
    }

    attribute_map = {
        'payees': 'payees'
    }

    def __init__(self, payees=None):  # noqa: E501
        """ResponseBankingPayeeListData"""  # noqa: E501

        self._payees = None
        self.discriminator = None

        self.payees = payees

    @property
    def payees(self):
        """Gets the payees of this ResponseBankingPayeeListData.  # noqa: E501

        The list of payees returned  # noqa: E501

        :return: The payees of this ResponseBankingPayeeListData.  # noqa: E501
        :rtype: list[BankingPayee]
        """
        return self._payees

    @payees.setter
    def payees(self, payees):
        """Sets the payees of this ResponseBankingPayeeListData.

        The list of payees returned  # noqa: E501

        :param payees: The payees of this ResponseBankingPayeeListData.  # noqa: E501
        :type: list[BankingPayee]
        """
        if payees is None:
            raise ValueError("Invalid value for `payees`, must not be `None`")  # noqa: E501

        self._payees = payees

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResponseBankingPayeeListData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResponseBankingPayeeListData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
