# BSD 3-Clause "New" or "Revised" License (BSD-3-Clause) 
# Copyright (c) 2020 Stephen McCalman. All rights reserved.

"""
A Python client package for accessing data from an API that follows the Consumer Data Standards (CDS).
CDS repo: https://consumerdatastandardsaustralia.github.io/standards

Generated with the Swagger-Codegen CLI from a Swagger specification file of the Consumer Data Standards.
Do not edit this file manually. CLI repo: https://github.com/swagger-api/swagger-codegen
    
The package is NOT part of the official Consumer Data Standards' project nor any API implementation of the Standards.
Package repo: https://github.com/stephenmccalman/cds-python-api-client
"""


import pprint
import re  # noqa: F401

class ResponseBankingScheduledPaymentsListData(object):
    """ResponseBankingScheduledPaymentsListData class."""
    


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'scheduled_payments': 'list[BankingScheduledPayment]'
    }

    attribute_map = {
        'scheduled_payments': 'scheduledPayments'
    }

    def __init__(self, scheduled_payments=None):  # noqa: E501
        """ResponseBankingScheduledPaymentsListData"""  # noqa: E501

        self._scheduled_payments = None
        self.discriminator = None

        self.scheduled_payments = scheduled_payments

    @property
    def scheduled_payments(self):
        """Gets the scheduled_payments of this ResponseBankingScheduledPaymentsListData.  # noqa: E501

        The list of scheduled payments to return  # noqa: E501

        :return: The scheduled_payments of this ResponseBankingScheduledPaymentsListData.  # noqa: E501
        :rtype: list[BankingScheduledPayment]
        """
        return self._scheduled_payments

    @scheduled_payments.setter
    def scheduled_payments(self, scheduled_payments):
        """Sets the scheduled_payments of this ResponseBankingScheduledPaymentsListData.

        The list of scheduled payments to return  # noqa: E501

        :param scheduled_payments: The scheduled_payments of this ResponseBankingScheduledPaymentsListData.  # noqa: E501
        :type: list[BankingScheduledPayment]
        """
        if scheduled_payments is None:
            raise ValueError("Invalid value for `scheduled_payments`, must not be `None`")  # noqa: E501

        self._scheduled_payments = scheduled_payments

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResponseBankingScheduledPaymentsListData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResponseBankingScheduledPaymentsListData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
