# BSD 3-Clause "New" or "Revised" License (BSD-3-Clause) 
# Copyright (c) 2020 Stephen McCalman. All rights reserved.

"""
A Python client package for accessing data from an API that follows the Consumer Data Standards (CDS).
CDS repo: https://consumerdatastandardsaustralia.github.io/standards

Generated with the Swagger-Codegen CLI from a Swagger specification file of the Consumer Data Standards.
Do not edit this file manually. CLI repo: https://github.com/swagger-api/swagger-codegen
    
The package is NOT part of the official Consumer Data Standards' project nor any API implementation of the Standards.
Package repo: https://github.com/stephenmccalman/cds-python-api-client
"""


import pprint
import re  # noqa: F401

class ResponseDiscoveryOutagesListData(object):
    """ResponseDiscoveryOutagesListData class."""
    


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'outages': 'list[DiscoveryOutage]'
    }

    attribute_map = {
        'outages': 'outages'
    }

    def __init__(self, outages=None):  # noqa: E501
        """ResponseDiscoveryOutagesListData"""  # noqa: E501

        self._outages = None
        self.discriminator = None

        self.outages = outages

    @property
    def outages(self):
        """Gets the outages of this ResponseDiscoveryOutagesListData.  # noqa: E501

        List of scheduled outages. Property is mandatory but may contain and empty list if no outages are scheduled  # noqa: E501

        :return: The outages of this ResponseDiscoveryOutagesListData.  # noqa: E501
        :rtype: list[DiscoveryOutage]
        """
        return self._outages

    @outages.setter
    def outages(self, outages):
        """Sets the outages of this ResponseDiscoveryOutagesListData.

        List of scheduled outages. Property is mandatory but may contain and empty list if no outages are scheduled  # noqa: E501

        :param outages: The outages of this ResponseDiscoveryOutagesListData.  # noqa: E501
        :type: list[DiscoveryOutage]
        """
        if outages is None:
            raise ValueError("Invalid value for `outages`, must not be `None`")  # noqa: E501

        self._outages = outages

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResponseDiscoveryOutagesListData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResponseDiscoveryOutagesListData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
